import { EngineSchemaProvider } from 'apollo-language-server/lib/providers/schema/engine';

class ApolloEngineLoader {
    loaderId() {
        return 'apollo-engine';
    }
    async canLoad(ptr) {
        return typeof ptr === 'string' && ptr === 'apollo-engine';
    }
    canLoadSync() {
        return false;
    }
    async load(_, options) {
        const engineSchemaProvider = new EngineSchemaProvider(options);
        const schema = await engineSchemaProvider.resolveSchema({});
        return {
            location: 'apollo-engine',
            schema,
        };
    }
    loadSync() {
        throw new Error('Loader ApolloEngine has no sync mode');
    }
}

export { ApolloEngineLoader };
